/// Articulations and Bridges
/// 
/// Time: O(V + E)
/// Space: O(V + E)

vector<int> graph[MAX];

struct ArticulationsBridges {
    int N;
    vector<int> vis, par, L, low;

    vector<p<int>> brid;
    vector<int> arti;

    ArticulationsBridges(int N) :
        N(N), vis(N), 
        par(N), L(N), low(N) 
    { init(); }

    void init() {
        fill(all(L), 0);
        fill(all(vis), 0);
        fill(all(par), -1);
    }

    void dfs(int x) {
        int child = 0;
        vis[x] = 1;

        for (auto i : graph[x]) {
            if (!vis[i]) {
                child++;
                par[i] = x;

                low[i] = L[i] = L[x] + 1;
                dfs(i);
                low[x] = min(low[x], low[i]);

                if ((par[x] == -1 && child > 1) || 
                        (par[x] != -1 && low[i] >= L[x]))
                    arti.pb(x);

                if (low[i] > L[x])
                    brid.pb(p<int>(x, i));

            } else if (par[x] != i)
                low[x] = min(low[x], L[i]);
        }
    }

    void run() {
        for (int i = 0; i < N; ++i)
            if (!vis[i])
                dfs(i);

        sort(all(arti));
        arti.erase(unique(all(arti)), arti.end());
    }
};
