/// Bipartite Matching
///
/// Time: O(V * E)
/// Space: O(V * E)

vector<int> graph[MAX];

struct BipartiteMatching {
    int N;
    vector<int> vis, match;

    BipartiteMatching(int N) :
        N(N), vis(N), match(N) 
    { init(); }

    void init() {
        fill(all(vis), 0);
        fill(all(match), -1);
    }

    int dfs(int x) {
        if (vis[x]) return 0;

        vis[x] = 1;
        for (auto i : graph[x])
            if (match[i] == -1 || dfs(match[i])) {
                match[i] = x;
                return 1;
            }

        return 0;
    }

    int run() {
        int ans = 0;
        for (int i = 0; i < N; ++i)
            ans += dfs(i);
        return ans;
    }
};
