/// Floyd Warshall
///
/// Time: O(V^3)
/// Space: O(V^2)

int dist[MAX][MAX];
int graph[MAX][MAX];

void floyd_warshall(int n) {
    mset(dist, inf);

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            if (graph[i][j]) 
                dist[i][j] = graph[i][j];

    for (int k = 0; k < n; ++k)
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                dist[i][j] = min(dist[i][j], 
                        dist[i][k] + dist[k][j]);
}
