/// Prim
///
/// Time: O(E log E)
/// Space: O(V + E)

vector<p<int>> graph[MAX];

struct Prim {
    int N;
    vector<int> vis;

    Prim(int N) :
        N(N), vis(N)
    { init(); }

    void init() {
        fill(all(vis), 0);
    }

    int run() {
        vis[0] = true;
        priority_queue<p<int>> pq;
        for (auto i : graph[0])
            pq.push({-i.se, -i.fi});

        int ans = 0;
        while (!pq.empty()) {
            p<int> front = pq.top(); pq.pop();
            int u = -front.se;
            int w = -front.fi;

            if (!vis[u]) {
                ans += w;
                vis[u] = true;
                for (auto i : graph[u])
                    if (!vis[i.fi])
                        pq.push({-i.se, -i.fi});
            }
        }

        return ans;
    }
};
