/// Euler Totient ($\phi$)
///
/// Time: O(sqrt{n})
/// Space: O(1)

i64 phi(i64 n) {
    i64 ans = n;

    for (i64 i = 2; i*i <= n; i++)
        if (n % i == 0) {
            while (n % i == 0) n /= i;
            ans -= ans / i;
        }

    if (n > 1)
        ans -= (ans / n);

    return ans;
}
