/// Extended Euclidean algorithm
/// 
/// Time: O(log min(a,b))
/// Space: O(1)

struct ans_t { i64 x, y, d; };

ans_t ext_gcd(i64 a, i64 b) {
    if (a == 0) return {0, 1, b};
    ans_t e = ext_gcd(b % a, a);
    return {e.y - (b/a)*e.x, e.x, e.d};
}
