/// Matrix
///
/// Space: O(R * C)

template <typename T>
struct Matrix {
    int r, c;
    vector<vector<T>> m;

    Matrix(int r, int c) : r(r), c(c) {
        m = vector<vector<T>>(r, vector<T>(c, 0));
    }

    Matrix operator*(Matrix a) {
        assert(r == a.c && c == a.r);

        Matrix res(r, c);
        for (int i = 0; i < r; i++)
            for (int j = 0; j < c; j++) {
                res[i][j] = 0;

                for (int k = 0; k < c; k++)
                    res[i][j] += m[i][k] * a[k][j];
            }

        return res;
    }

    vector<T> &operator[](int i) {
        return m[i];
    }
};
