/// Sieve of Eratosthenes
///
/// Time: O(n * log log n)
/// Space: O(n)

vector<int> sieve(int n) {
    vector<int> primes;
    vector<int> is_prime(n + 1, 1);

    for (int p = 2; p*p <= n; ++p)
        if (is_prime[p])
            for (int i = p*p; i <= n; i += p)
                is_prime[i] = false;

    for (int p = 2; p <= n; ++p)
        if (is_prime[p])
            primes.pb(p);

    return primes;
}
