/// Dynamic Programming, Divide and Conquer Optimization
///
/// Time: O(n * m * log n)
/// Space: O(n * m)

vector<int> v;
int dp[102][20101];

void solve(int g, int i, int j, int l, int r) {
    int m = (i + j) / 2;
    if (i > j) return;

    p<int> best = { -inf, -1 };
    for (int k = l; k <= min(r, m); ++k) {
        mx = max(mx, v[k]);
        mn = min(mn, v[k]);
        best = max(best, { dp[g-1][k-1] + cost(k, m), k });
    }

    dp[g][m] = best.fi;
    solve(g, i, m - 1, l, best.se);
    solve(g, m + 1, j, best.se, r);
}

int calc() {
    // setup dp[0][i];

    for (int i = 1; i <= k; ++i)
        solve(i, 1, n, 1, n);

    return dp[k][n];
}
