/// Longest Increasing Subsequence (LIS)
///
/// Time: O(n^2)
/// Space: O(n)

int lis(vector<int> v) {
    vector<int> lis(v.size()); lis[0] = 1;

    for (int i = 1; i < v.size(); ++i) {
        lis[i] = 1;

        for (int j = 0; j < i; ++j)
            if (v[i] > v[j] && lis[i] < lis[j] + 1)
                lis[i] = lis[j] + 1;
    }

    return *max_element(all(lis));
}
