/// Longest Common Subsequence
///
/// Time: O(n * m)
/// Space: O(n * m)

int dp[MAX][MAX];

string lcs(string a, string b) {
    for (int i = 0; i <= a.size(); ++i) {
        for (int j = 0; j <= b.size(); ++j) {
            if (i == 0 || j == 0)
                dp[i][j] = 0;
            else if (a[i - 1] == b[j - 1])
                dp[i][j] = dp[i - 1][j - 1] + 1;
            else
                dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
        }
    }

    // The size is already at dp[n][m], now the common 
    // subsequence is retrieved:

    int idx = dp[a.size()][b.size()];
    string ans(idx, ' ');

    int i = a.size(), j = b.size();
    while (i > 0 && j > 0) {
        if (a[i - 1] == b[ j - 1]) {
            ans[idx - 1] = a[i - 1];
            i--, j--, idx--;
        } else if (dp[i - 1][j] > dp[i][j - 1]) 
            i--;
        else 
            j--;
    }

    return ans;
}
