/// Bitmask
///
/// Time: O(1)
/// Space: O(1)

struct Bitmask {
    i64 state;

    Bitmask(i64 state) :
        state(state) {}

    void set(int pos) { 
        state |= (1 << pos); 
    }

    void set_all(int n) { 
        state = (1 << n) - 1; 
    }

    void unset(int pos) { 
        state &= ~(1 << pos); 
    }

    void unset_all() { 
        state = 0; 
    }

    int get(int pos) { 
        return state & (1 << pos); 
    }

    void toggle(int pos) { 
        state ^= (1 << pos); 
    }

    int least_significant_one() {
        return state & (-state); 
    }
};
