/// Mo's Algorithm
///
/// Time: O((n + q) * sqrt{n})
/// Space: O(n + q)
///
/// Caution:
///   - Remember to implement add, remove, and get\_ans functions.

struct Query {
    int l, r, idx;
};

vector<int> mos_algorithm(vector<Query> Q) {
    int blk_size = (int) sqrt(v.size() + 0.0) + 1;

    vector<int> ans(Q.size());
    sort(all(Q), [](Query a, Query b) {
            return p<int>(a.l / blk_size, a.r) < p<int>(b.l / blk_size, b.r);
            });

    int curr_l = 0, curr_r = -1;

    for (auto q : Q) {
        while (curr_l > q.l) {
            curr_l--;
            add(curr_l);
        }
        while (curr_r < q.r) {
            curr_r++;
            add(curr_r);
        }
        while (curr_l < q.l) {
            remove(curr_l);
            curr_l++;
        }
        while (curr_r > q.r) {
            remove(curr_r);
            curr_r--;
        }

        ans[q.idx] = get_ans();
    }

    return ans;
}
