/// Policy Tree
/// 
/// Description:
/// A set-like STL structure with order statistics.
/// 
/// Time:
///   - insert:        O(log n)
///   - erase:         O(log n)
///   - find_by_order: O(log n)
///   - order_of_key:  O(log n)
/// Space: O(n)

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, 
      tree_order_statistics_node_update>;

void operations() {
    ordered_set S;

    S.insert(x);
    S.erase(x);

    // Return iordered_set terator to the k-th largest element 
    // (counting from zero)
    int pos = *S.find_by_order(k);

    // Return the number of items strictly smaller 
    // than x
    int ord = S.order_of_key(x)
}
