/// Easy Sudoku

#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

vector<vector<int>> mat, filled;
vector<int> init = {0, 0, 0, 3, 3, 3, 6, 6, 6};

int check(int r, int c) {
    int ans = 0;
    for (int i = 0; i < 9; ++i) ans |= (1 << mat[r][i]);
    for (int i = 0; i < 9; ++i) ans |= (1 << mat[i][c]);

    for (int i = init[r]; i < init[r] + 3; ++i)
        for (int j = init[c]; j < init[c] + 3; ++j)
            ans |= (1 << mat[i][j]);

    return ans;
}

bool solve(int i, int j) {
    if (filled[i][j]) {
        if (i == 8 && j == 8) return true;
        else return solve(i + (j == 8), (j + 1) % 9);
    }

    int poss = check(i, j);
    for (int k = 1; k <= 9; ++k) {
        if ((poss & (1 << k)) == 0) {
            mat[i][j] = k;
            if (i == 8 && j == 8) return true;
            if (solve(i + (j == 8), (j + 1) % 9)) return true;
            mat[i][j] = filled[i][j];
        }
    }

    return false;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    mat.resize(9, vector<int>(9));

    int n; cin >> n;
    for (int cas = 0; cas < n; ++cas) {
        for (auto &i : mat)
            for (auto &j : i)
                cin >> j;

        filled = mat;

        if (solve(0, 0))
            for (auto &i : mat) {
                for (auto j : i) cout << j << " ";
                cout << ende;
            }
        else 
            cout << "No solution" << ende;
    }

    return 0;
}
