/// Internet Bandwidth

#include <bits/stdc++.h>

#define MAX 1000
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define sz size()
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

typedef long long ll;
typedef pair<int,int> ii;

int N;
int par[MAX];
int graph[MAX][MAX], rg[MAX][MAX];

bool cont[MAX];

bool path(int s, int t) {
    queue<int> Q;
    Q.push(s);
    cont[s] = true;

    while (!Q.empty()) {
        int u = Q.front(); Q.pop();

        if (u == t)
            return true;

        for (int i = 0; i < N; ++i)
            if (!cont[i] && rg[u][i]) {
                cont[i] = true;
                par[i] = u;
                Q.push(i);
            }
    }

    return false;
}


int edmonds_karp(int s, int t) {
    int ans = 0;
    par[s] = -1;

    mset(cont, 0);
    memcpy(rg, graph, sizeof(graph));

    while (path(s, t)) {
        int flow = inf;

        for (int i = t; par[i] != -1; i = par[i])
            flow = min(flow, rg[par[i]][i]);

        for (int i = t; par[i] != -1; i = par[i]) {
            rg[par[i]][i] -= flow;
            rg[i][par[i]] += flow;
        }

        ans += flow;
        mset(cont, 0);
    }

    return ans;
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, cas = 1;
    while (cin >> n && n) {
        N = n;
        int s, t, c; cin >> s >> t >> c;

        mset(graph, 0);
        for (int i = 0; i < c; ++i) {
            int o, d, ca; cin >> o >> d >> ca;
            o--, d--;
            graph[o][d] += ca;
            graph[d][o] += ca;
        }

        cout << "Network " << cas++ << ende;
        cout << "The bandwidth is " << edmonds_karp(s-1, t-1) << "." << ende;
        cout << ende;
    }

    return 0;
}
