/// Mercado do Cairo

#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

struct BIT2D {
    int N, M;
    vector<vector<int>> tree;

    BIT2D(int N, int M) :
        N(N), M(M), tree(N, vector<int>(M))
    { init(); }

    void init() {
        for (auto &i : tree)
            fill(all(i), 0);
    }

    int query(int idx, int idy) {
        int sum = 0;
        for (; idx > 0; idx -= (idx & -idx))
            for (int m = idy; m > 0; m -= (m & -m))
                sum = max(sum, tree[idx][m]);
        return sum;
    }

    void update(int idx, int idy, int val) {
        for (; idx < N; idx += (idx & -idx))
            for (int m = idy; m < M; m += (m & -m))
                tree[idx][m] = max(tree[idx][m], val);
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t; cin >> t;
    for (int cas = 1; cas <= t; ++cas) {
        BIT2D bit(1001, 1001);

        int n; cin >> n;
        vector<int> x(n), y(n);
        for (int i = 0; i < n; ++i)
            cin >> x[i] >> y[i];

        for (int i = 0; i < n; ++i)
            bit.update(x[i], y[i], 1 + bit.query(x[i], y[i]));
        cout << bit.query(1000, 1000) << ende;
    }

    return 0;
}
