/// Cultivando Strings

#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

struct AhoCorasick {
    struct Node {
        int fail, occ;
        vector<int> words;
        map<char,int> next;

        Node() : fail(0), occ(-1) {}
        int has(char i) { return next.count(i); }
        int &operator[](char i) { return next[i]; }
    };

    vector<Node> trie;

    AhoCorasick(const vector<string> &v) {
        trie.pb(Node());
        build(v);
        preprocess();
    }

    int insert(const string &s) {
        int n = 0;
        for (int i = 0; i < s.size(); n = trie[n][s[i]], ++i)
            if (!trie[n].has(s[i])) {
                trie[n][s[i]] = trie.size();
                trie.pb(Node());
            }
        return n;
    }

    void build(const vector<string> &v) {
        for (int i = 0; i < v.size(); ++i) {
            int n = insert(v[i]);
            trie[n].words.pb(i);
        }
    }

    inline int suffix(int v, char c) {
        while (v != 0 && !trie[v].has(c)) v = trie[v].fail;
        if (trie[v].has(c)) v = trie[v][c];
        return v;
    }

    void preprocess() {
        vector<int> Q = { 0 };
        for (int i = 0; i != Q.size(); ++i) {
            int u = Q[i];
            for (auto j : trie[u].next) {
                int &v = trie[j.se].fail;
                if (u) {
                    v = suffix(trie[u].fail, j.fi);
                    trie[j.se].occ = trie[v].words.size() ? v : trie[v].occ;
                } else {
                    v = trie[u].fail;
                    trie[j.se].occ = -1;
                }
                Q.pb(j.se);
            }
        }
    }
};

int n;
int dp[10101];
vector<string> v;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    while (cin >> n && n) {
        v.clear();
        v.resize(n);
        for (auto &i : v) 
            cin >> i;

        sort(all(v), [](const string &a, const string &b) { 
                return a.size() > b.size(); 
                });

        AhoCorasick aho(v);
        for (int i = n - 1; i >= 0; --i) {
            int grt = 0, u = 0;
            for (auto j : v[i]) {
                u = aho.suffix(u, j);
                for (auto k : aho.trie[u].words)
                    if (k != i)
                        grt = max(grt, dp[k] + 1);

                int x = u;
                while (aho.trie[x].occ != -1) {
                    x = aho.trie[x].occ;
                    for (auto k : aho.trie[x].words)
                        if (k != i)
                            grt = max(grt, dp[k] + 1);
                }
            }
            dp[i] = grt;
        }

        cout << (*max_element(dp, dp + n) + 1) << ende;
    }

    return 0;
}
