/// I Love Strings! (kmp)

#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

struct KMP {
    string patt;
    vector<int> table;

    KMP(string patt) :
        patt(patt), table(patt.size()+1)
    { preprocess(); }

    void preprocess() {
        fill(all(table), -1);

        for (int i = 0, j = -1; i < patt.size(); ++i) {
            while (j >= 0 && patt[i] != patt[j]) 
                j = table[j];
            table[i + 1] = ++j;
        }
    }

    bool search(const string &txt) {
        bool found = false;

        for (int i = 0, j = 0; i < txt.size(); ++i) {
            while (j >= 0 && txt[i] != patt[j]) 
                j = table[j];
            j++;

            if (j == patt.size()) {
                found = true;
                j = table[j];
            }
        }

        return found;
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t; cin >> t;
    for (int cas = 1; cas <= t; ++cas) {
        string s; cin >> s;
        int q; cin >> q;
        for (int i = 0; i < q; ++i) {
            string t; cin >> t;
            KMP kmp(t);
            cout << ((kmp.search(s)) ? "y" : "n") << ende;
        }
    }

    return 0;
}
