/// G. Game of Matchings

#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

struct KMP {
    vector<int> patt;
    vector<int> table;

    KMP(vector<int> patt) :
        patt(patt), table(patt.size()+1)
    { preprocess(); }

    void preprocess() {
        fill(all(table), -1);

        for (int i = 0, j = -1; i < patt.size(); ++i) {
            while (j >= 0 && patt[i] != patt[j] && (patt[j] || patt[i] <= j))
                j = table[j];
            table[i + 1] = ++j;
        }
    }

    int search(const vector<int> &txt) {
        int ans = 0;
        for (int i = 0, j = 0; i < txt.size(); ++i) {
            while (j >= 0 && txt[i] != patt[j] && (patt[j] || txt[i] <= j))
                j = table[j];
            ++j;
            if (j == patt.size()) {
                ans++;
                j = table[j];
            }
        }

        return ans;
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    string s; cin >> s;
    int n; cin >> n;
    vector<int> v(n);
    for (auto &i : v) {
        cin >> i; --i; 
    }

    vector<int> last(30, -1);
    vector<int> A(s.size()), B(n);
    for (int i = 0; i < s.size(); ++i) {
        if (last[s[i] - 'a'] == -1) A[i] = 0;
        else A[i] = i - last[s[i] - 'a'];
        last[s[i] - 'a'] = i;
    }

    fill(all(last), -1);
    for (int i = 0; i < v.size(); ++i) {
        if (last[v[i]] == -1) B[i] = 0;
        else B[i] = i - last[v[i]];
        last[v[i]] = i;
    }

    KMP kmp(B);
    cout << kmp.search(A) << ende;
    return 0;
}
