/// F. Fundraising

#include <bits/stdc++.h>

#define MAX 101010
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<ll,ll>;
using iii = pair<ii,ll>;

struct BIT {
    int N;
    vector<ll> tree;

    BIT(int N) :
        N(N), tree(N)
    {}

    void init() {
        fill(all(tree), 0LL);
    }

    ll query(int idx) {
        ll sum = 0LL;
        for (; idx > 0; idx -= (idx & -idx))
            sum = max(sum, tree[idx]);
        return sum;
    }

    void update(int idx, ll val) {
        for (; idx < N; idx += (idx & -idx))
            tree[idx] = max(tree[idx], val);
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    BIT bit(MAX);
    bit.init();

    map<ii,ll> M;
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        ll a, b, c; cin >> a >> b >> c;
        M[ii(a, b)] += c;
    }

    vector<iii> v;
    for (auto i : M)
        v.pb(iii(ii(i.fi.fi, i.fi.se), i.se));
    n = v.size();

    sort(all(v), [](const iii &a, const iii &b) {
            if (a.fi.fi != b.fi.fi)
            return a.fi.fi < b.fi.fi;
            else if (a.fi.se != b.fi.se)
            return a.fi.se > b.fi.se;
            return a.se > b.se;
            });

    set<ll> S;
    map<ll,ll> compress;
    for (auto i : v)
        S.insert(i.fi.se);

    ll k = 1LL;
    for (auto i : S)
        compress[i] = k++;
    for (auto &i : v)
        i.fi.se = compress[i.fi.se];

    ll ans = 0, last = v[0].fi.fi;
    for (int i = 0; ; ) {
        for (; i < n && v[i].fi.fi == last; ++i) {
            ll bst = max(bit.query(v[i].fi.se - 1) + v[i].se, 
                    bit.query(v[i].fi.se));

            bit.update(v[i].fi.se, bst);
            ans = max(ans, bst);
        }

        if (i >= n) break;
        last = v[i].fi.fi;
    }

    cout << ans << ende;
    return 0;
}
