/// G. Gates of uncertainty

#include <bits/stdc++.h>

#define MAX 101010
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

map<int,ii> forw;
map<ii,int> backw;
int L[MAX], R[MAX], val[MAX];

struct comb {
    ll pos[4];

    comb() { mset(pos, 0); }

    static comb base() {
        comb res;
        res.pos[0] = res.pos[3] = 1;
        return res;
    }
};

comb dfs(int x) {
    comb res;
    comb l = (L[x]) ? (dfs(L[x])) : (comb::base());
    comb r = (R[x]) ? (dfs(R[x])) : (comb::base());

    for (int i = 0; i < 4; ++i)
        for (int j = 0; j < 4; ++j) {
            ii nand = ii(!(forw[i].fi && forw[j].fi), !(forw[i].se && forw[j].se));
            res.pos[backw[nand]] = (res.pos[backw[nand]] + 
                    (l.pos[i] % MOD) * (r.pos[j] % MOD)) % MOD;
        }

    if (val[x] == 0) {
        res.pos[0] = (res.pos[0] + res.pos[2]) % MOD, res.pos[2] = 0;
        res.pos[1] = (res.pos[1] + res.pos[3]) % MOD, res.pos[3] = 0;
    } else if (val[x] == 1) {
        res.pos[2] = (res.pos[2] + res.pos[0]) % MOD, res.pos[0] = 0;
        res.pos[3] = (res.pos[3] + res.pos[1]) % MOD, res.pos[1] = 0;
    }

    return res;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> L[i] >> R[i] >> val[i];

    forw[0] = ii(0, 0); backw[ii(0, 0)] = 0;
    forw[1] = ii(0, 1); backw[ii(0, 1)] = 1;
    forw[2] = ii(1, 0); backw[ii(1, 0)] = 2;
    forw[3] = ii(1, 1); backw[ii(1, 1)] = 3;

    comb ans = dfs(1);
    cout << (ans.pos[1] + ans.pos[2]) % MOD << ende;
    return 0;
}
