/// F. Fantastic Beasts

#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<ll,ll>;

struct ans_t { ll x, y, d; };

ans_t ext_gcd(ll a, ll b) {
    if (a == 0) return {0, 1, b};
    ans_t e = ext_gcd(b % a, a);
    return {e.y - (b/a) * e.x, e.x, e.d};
}

ll norm(ll a, ll b) { 
    a %= b; 
    return (a < 0) ? a + b : a;
}

pair<ll,ll> crt_single(ll a, ll n, ll b, ll m) {
    ans_t e = ext_gcd(n, m);

    if ((a - b) % e.d != 0)
        return {-1,-1};

    ll lcm = (m/e.d) * n;
    ll ans = norm(a + e.x*(b-a) / e.d % (m/e.d)*n, lcm);
    return {norm(ans, lcm), lcm};
}

ll crt(vector<ll> a, vector<ll> m) {
    ll ans = a[0];
    ll lcm = m[0];

    int t = a.size();
    for (int i = 1; i < t; ++i) {
        auto ss = crt_single(ans, lcm, a[i], m[i]);
        if (ss.fi == -1)
            return -1;

        ans = ss.fi;
        lcm = ss.se;
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int b, z; cin >> b >> z;
    vector<vector<int>> mat(b, vector<int>(z+1));
    vector<vector<int>> time(z+1, vector<int>(501));
    vector<vector<ll>> a(z + 1, vector<ll>(b, -1));
    vector<vector<ll>> m(z + 1, vector<ll>(b, -1));

    for (auto &i : mat) 
        for (auto &j : i) cin >> j;

    for (int i = 0; i < b; ++i) {
        int curr = mat[i][0];
        time[curr][0] |= (1 << i);

        for (int t = 1; t <= 500; ++t) {
            curr = mat[i][curr]; 
            time[curr][t] |= (1 << i);
        }
    }

    for (int i = 1; i <= z; ++i) {
        for (int t = 0; t <= 500; ++t) {
            if (time[i][t] == (1 << b) - 1)
                return cout << i << " " << t << ende, 0;

            for (int j = 0; j < b; ++j)
                if (time[i][t] & (1 << j)) {
                    if (a[i][j] == -1)
                        a[i][j] = t;
                    else if (m[i][j] == -1)
                        m[i][j] = t - a[i][j];
                }
        }
    }

    ll zoo = 0;
    ll ans = llinf*2;
    for (int i = 1; i <= z; ++i) {
        bool poss = true;
        for (int j = 0; j < b; ++j)
            if (a[i][j] == -1 || m[i][j] == -1) {
                poss = false;
                break;
            }

        if (!poss) 
            continue;

        ll res = crt(a[i], m[i]);
        if (res == -1) 
            continue;
        else {
            if (ans > res && res > 0)
                zoo = i, ans = res;
        }
    }

    if (ans == llinf*2) cout << "*" << ende;
    else cout << zoo << " " << ans << ende;
    return 0;
}
