#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

vector<int> sieve(int n) {
    vector<int> primes;
    vector<int> is_prime(n + 1, 1);

    for (int p = 2; p*p <= n; ++p)
        if (is_prime[p])
            for (int i = p*p; i <= n; i += p)
                is_prime[i] = false;

    for (int p = 2; p <= n; ++p)
        if (is_prime[p])
            primes.pb(p);

    return primes;
}

struct ans_t { ll x, y, d; };

ans_t ext_gcd(ll a, ll b) {
    if (a == 0) return {0, 1, b};
    ans_t e = ext_gcd(b % a, a);
    return {e.y - (b/a)*e.x, e.x, e.d};
}

int extended_euclidean(int a, int m) {
    ans_t g = ext_gcd(a, m);
    return (g.x % m + m) % m;
}

ll bin_exp(ll a, ll e, ll M = MOD) {
    ll x = 1;
    while (e) {
        if (e & 1) x = (x * a) % M;
        e >>= 1;
        a = (a * a) % M;
    }
    return x % M;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    ll n, e, c; cin >> n >> e >> c;
    vector<int> primes = sieve((int) sqrt(n)+1);

    for (int i = 0; i < primes.size() && primes[i]*primes[i] <= n; ++i) {
        if (n % primes[i] == 0) {
            ll p = primes[i];
            ll q = n / p;

            if (p % 2 == 0 || q % 2 == 0)
                continue;

            ll phi = (p - 1) * (q - 1);
            if (e >= phi || __gcd(phi, e) != 1)
                continue;

            ll d = extended_euclidean(e, phi);
            ll m = bin_exp(c, d, n);

            if (bin_exp(m, e, n) == c && m > 0)
                return cout << m << ende, 0;
        }
    }

    return 0;
}
