/// C. Cortador de Pizza

#include <bits/stdc++.h>

#define MAX 101010
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

int tree[MAX];

int query(int idx) {
    int sum = 0;
    for ( ; idx > 0; idx -= (idx & -idx))
        sum += tree[idx];
    return sum;
}

void update(int idx, int val) {
    for ( ; idx < MAX; idx += (idx & -idx))
        tree[idx] += val;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int x, y; cin >> x >> y;
    int h, v; cin >> h >> v;
    vector<ii> H(h), V(v);

    for (int i = 0; i < h; ++i) {
        int x1, x2; cin >> x1 >> x2;
        H[i] = ii(x1, x2);
    }

    for (int i = 0; i < v; ++i) {
        int y1, y2; cin >> y1 >> y2;
        V[i] = ii(y1, y2);
    }

    sort(all(H));
    for (int i = 0; i < h; ++i)
        H[i].fi = i + 1;
    sort(all(H), [](ii a, ii b) {
            return a.se < b.se;
            });

    sort(all(V));
    for (int i = 0; i < v; ++i)
        V[i].fi = i + 1;
    sort(all(V), [](ii a, ii b) {
            return a.se < b.se;
            });

    ll ans = (h + 1LL) * (v + 1LL);
    for (int i = h - 1; i >= 0; --i) {
        ans += query(H[i].fi);
        update(H[i].fi, 1);
    }

    mset(tree, 0);
    for (int i = v - 1; i >= 0; --i) {
        ans += query(V[i].fi);
        update(V[i].fi, 1);
    }

    cout << ans << ende;
    return 0;
}
