#include <bits/stdc++.h>

#define MAX 1010
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

struct Circle {
    int x, y, r;
    Circle() {}

    bool inter(Circle c) {
        return (c.x - x)*(c.x - x) + (c.y - y)*(c.y - y) <= (c.r + r)*(c.r + r);
    }
};

#define R 1001
#define L 1002
#define U 1003
#define D 1004

int par[MAX];
int rnk[MAX];

int find_set(int x) {
    if (par[x] != x)
        par[x] = find_set(par[x]);
    return par[x];
}

void union_set(int a, int b) {
    a = find_set(a);
    b = find_set(b);

    if (a == b) return;
    if (rnk[a] < rnk[b]) swap(a, b);
    if (rnk[a] == rnk[b]) rnk[a]++;
    par[b] = a;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int m, n, k; cin >> m >> n >> k;
    vector<Circle> v(k);

    for (auto &i : v)
        cin >> i.x >> i.y >> i.r;

    iota(par, par + MAX, 0);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j)
            if (v[i].inter(v[j]))
                union_set(i, j);

        if (v[i].x + v[i].r >= m) union_set(R, i);
        if (v[i].x - v[i].r <= 0) union_set(L, i);
        if (v[i].y + v[i].r >= n) union_set(U, i);
        if (v[i].y - v[i].r <= 0) union_set(D, i);
    }

    if (find_set(R) == find_set(L) ||
            find_set(L) == find_set(D) ||
            find_set(U) == find_set(D) ||
            find_set(R) == find_set(U))
        cout << "N" << ende;
    else
        cout << "S" << ende;

    return 0;
}
