#include <bits/stdc++.h>

#define MAX 101010
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

#define left(x) (x << 1)
#define right(x) ((x << 1) + 1)

int N = 100001;
int tree[MAX*4], cnt[MAX*4];

void update(int i, int j, int val, 
        int node = 1, int l = 0, int r = N - 1) {
    if (l > r || l > j || r < i) return;

    if (i <= l && r <= j)
        tree[node] += val;
    else {
        int m = (l + r) / 2;
        update(i, j, val, left(node), l, m);
        update(i, j, val, right(node), m + 1, r);
    }

    if (tree[node])
        cnt[node] = r - l + 1;
    else {
        cnt[node] = 0;
        if (l < r) cnt[node] = cnt[left(node)] + cnt[right(node)];
    }
}

struct Segment {
    int x1, y1, x2, y2;

    Segment() {}
    Segment(int x1, int y1, int x2, int y2) :
        x1(x1), y1(y1), x2(x2), y2(y2) {}
};

struct Event {
    int x1, x2, y;
    int beg;

    Event() {}
    Event(int x1, int x2, int y, int b) : 
        x1(x1), x2(x2), y(y), beg(b) {}
};

Segment rect;
vector<Event> E;
vector<Segment> ss;

double calc(int m, ll p) {
    mset(tree, 0);
    mset(cnt, 0);

    int k = 0;
    for (int i = 0; i < ss.size(); ++i) {
        E[k++] = Event(ss[i].x1 - m, ss[i].x2 + m, ss[i].y1 - m,  1);
        E[k++] = Event(ss[i].x1 - m, ss[i].x2 + m, ss[i].y2 + m, -1);
    }

    sort(all(E), [&](const Event &a, const Event &b) {
            return a.y < b.y;
            });

    k = 0;
    ll ans = 0;
    for (int i = rect.y1; i < rect.y2; ++i) {
        for (; k < E.size() && E[k].y <= i; ++k)
            if (E[k].x1 <= rect.x2 - 1 && E[k].x2 >= rect.x1)
                update(max(rect.x1, E[k].x1), min(rect.x2 - 1, E[k].x2 - 1), E[k].beg);
        ans += (ll) cnt[1];
    }

    return (ans*100) < p * ((ll) ((ll) rect.x2 - rect.x1) * ((ll) rect.y2 - rect.y1));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    E.resize(2*n);
    ss.resize(n);

    for (auto &i : ss) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        i = Segment(min(x1,x2), min(y1,y2), max(x1,x2), max(y1,y2));
    }

    ll p; cin >> p;
    int x1, y1, x2, y2;
    cin >> x1 >> y1 >> x2 >> y2;
    rect = Segment(min(x1,x2), min(y1,y2), max(x1,x2), max(y1,y2));

    int l = 0, r = 101010;
    for (int b = r / 2; b >= 1; b /= 2)
        while (calc(l + b, p))
            l += b;

    cout << l + 1 << ende;
    return 0;
}
