/// Crise Hidrica

#include <bits/stdc++.h>

#define MAX 5010
#define MAXLOG 20
#define MOD 1000000007
#define EPS 1e-6
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define sz size()
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

typedef long long ll;
typedef pair<int,int> ii;

int found;
ll dp[MAX][1010];
ll v[MAX];
vector<int> graph[MAX];

int h[MAX];
int par[MAX][MAXLOG];
ll upd[MAX];

void dfs(int va, int p = -1) {
    par[va][0] = p;

    if (p + 1)
        h[va] = h[p] + 1;

    for (int i = 1; i < MAXLOG; ++i)
        if (par[va][i - 1] + 1)
            par[va][i] = par[par[va][i - 1]][i - 1];

    for (auto u : graph[va]) 
        if (p != u)
            dfs(u, va);
}

void preprocess(int va) {
    memset(par, -1, sizeof par);
    dfs(va);
}

int query(int p, int q) {
    if (h[p] < h[q])
        swap(p, q);

    for (int i = MAXLOG - 1; i >= 0; --i)
        if (par[p][i] + 1 && h[par[p][i]] >= h[q]) {
            p = par[p][i];
        }

    if (p == q)
        return p;

    for (int i = MAXLOG - 1; i >= 0; --i)
        if (par[p][i] + 1 && par[p][i] != par[q][i]) {
            p = par[p][i];
            q = par[q][i];
        }

    return par[p][0];
}

ll fill(int x, int pare) {
    ll ans = 0;

    for (auto i : graph[x])
        if (i != pare)
            ans += fill(i, x);

    return v[x] = ans + upd[x];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, d, a, b;
    cin >> n >> d;
    for (int i = 0; i < n - 1; ++i) {
        cin >> a >> b;
        graph[a].pb(b);
        graph[b].pb(a);
    }

    int m, vv, c;
    cin >> m;
    vector<int> w(m+1), avail;
    for (int i = 0; i < m; ++i) {
        cin >> c >> vv;
        w[i+1] = vv;
        avail.pb(c);
    }

    preprocess(1);

    ll q, l;
    int x, y;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> x >> y >> l;
        int lca = query(x, y);

        upd[lca] -= l;
        upd[x] += l;
        upd[y] += l;
        if (lca != 1)
            upd[par[lca][0]] -= l;
    }

    fill(1, -1);

    vector<ll> vvv(m+1);
    for (int i = 0; i < m; ++i)
        vvv[i+1] = v[avail[i]];

    for (int i = 1; i <= m; ++i)
        for (int j = 0; j <= d; ++j)
            if (j >= w[i])
                dp[i][j] = max(dp[i-1][j], dp[i-1][j - w[i]] + vvv[i]);
            else
                dp[i][j] = dp[i-1][j];

    cout << dp[m][d] << ende;
    return 0;
}
