/// Exponial

#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

using ll = long long;
using ii = pair<int,int>;

ll phi(ll n) {
    ll result = n;

    for (ll i = 2; i*i <= n; i++) {
        if (n % i == 0) {
            while (n % i == 0) n /= i;
            result -= result / i;
        }
    }

    if (n > 1)
        result -= result / n;

    return result;
}

ll fast_pow(ll x, ll n, ll m) {
    ll ans = 1;

    while (n) {
        if (n & 1)
            ans = (ans * x) % m;

        n >>= 1;
        x = (x * x) % m;
    }

    return ans % m;
}

ll solve(ll n, ll m) {
    if (m == 1) 
        return 0;

    if (n <= 5) {
        if (n == 4) return 262144 % m;
        else if (n == 3) return 9 % m;
        else if (n == 2) return 2 % m;
        else if (n == 1) return 1 % m;
        else return fast_pow(5, 262144, m);
    }

    // n^e % m == n^(phi(m) + e % phi(m)) mod m
    ll p = phi(m);
    ll e = p + solve(n - 1, p) % p;
    return fast_pow(n, e, m); 
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    ll n, m; cin >> n >> m;
    cout << solve(n, m) << ende;

    return 0;
}
