/// Trees Partition

#include <bits/stdc++.h>

#define MAX 301010
#define MOD 1000000007
#define inf 0x3f3f3f3f

#define fi first
#define se second
#define sz size()
#define pb push_back

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef long long ll;
typedef pair<int,int> ii;

ll hsh[MAX];
vector<int> t1[MAX], t2[MAX];

unordered_map<ll, int> M;
ll ans = 0, tot = 0;

ll dfs(int x, int par) {
    ll down = hsh[x];

    for (auto i : t1[x]) {
        if (i != par) {
            ll bel = dfs(i, x);
            down ^= bel;
            M[bel] = 1;
        }
    }

    return down;
}

ll solve(int x, int par) {
    ll down = hsh[x];

    for (auto i : t2[x]) {
        if (i != par) {
            ll bel = solve(i, x);
            down ^= bel;

            if (M[bel] || M[bel ^ tot]) {
                ans++;
                M[bel] = M[bel ^ tot] = 0;
            }
        }
    }

    return down;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, x;
    cin >> n;
    mt19937_64 mt(time(NULL));

    for (int i = 0; i < n - 1; ++i) {
        cin >> x;
        t1[i+1].pb(x-1);
        t1[x-1].pb(i+1);
    }

    for (int i = 0; i < n - 1; ++i) {
        cin >> x;
        t2[i+1].pb(x-1);
        t2[x-1].pb(i+1);
    }

    for (int i = 0; i < n; ++i) {
        hsh[i] = mt();
        tot ^= hsh[i];
    }

    dfs(0, -1);
    solve(0, -1);

    cout << ans << '\n';
    return 0;
}
