/// XOR submatrix

#include <bits/stdc++.h>

#define MAX 10101010
#define EPS 1e-6
#define MOD 1000000007
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define sz size()
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

typedef long long ll;
typedef pair<int,int> ii;

int states = 0;
int trie[MAX][2];

void insert(int x) {
    int node = 0;

    for (int i = 30; i >= 0; --i) {
        int b = !!(x & (1 << i));

        if (trie[node][b] == -1)
            trie[node][b] = ++states;
        node = trie[node][b];
    }
}

int search(int x) {
    int node = 0;
    int ans = 0;

    for (int i = 30; i >= 0; --i) {
        int b = !(x & (1 << i));

        if (trie[node][b] == -1)
            b ^= 1;

        node = trie[node][b];
        ans |= (b << i);
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    mset(trie, -1);

    int n, m; cin >> n >> m;
    vector<int> v(n+1), u(m+1);

    v[0] = u[0] = 0;
    for (int i = 1; i <= n; ++i) {
        int x; cin >> x;
        v[i] = v[i-1] ^ x;
    }

    for (int i = 1; i <= m; ++i) {
        int x; cin >> x;
        u[i] = u[i-1] ^ x;
    }

    int ans = 0;
    for (int i = 0; i <= n; ++i)
        for (int j = i; j <= n; ++j)
            if ((j - i) % 2) 
                insert(v[i] ^ v[j]);
            else 
                ans = max(ans, v[i] ^ v[j]);

    for (int i = 0; i <= m; ++i)
        for (int j = i; j <= m; ++j)
            if ((j - i) % 2) 
                ans = max(ans, u[i] ^ u[j] ^ search(u[i] ^ u[j]));
            else 
                ans = max(ans, u[i] ^ u[j]);

    cout << ans << ende;
    return 0;
}
